<?php

namespace app\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\PedidoReportePrecios;

/**
 * PedidoReportePreciosSearch represents the model behind the search form of `app\models\PedidoReportePrecios`.
 */
class PedidoReportePreciosSearch extends PedidoReportePrecios
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'pedido_id', 'producto_id'], 'integer'],
            [['precio_1', 'precio_2', 'precio_3'], 'number'],
            [['orden_1', 'fecha_1', 'orden_2', 'fecha_2', 'orden_3', 'fecha_3'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     * @param string|null $formName Form name to be used into `->load()` method.
     *
     * @return ActiveDataProvider
     */
    public function search($params, $formName = null)
    {
        $query = PedidoReportePrecios::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params, $formName);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'pedido_id' => $this->pedido_id,
            'producto_id' => $this->producto_id,
            'precio_1' => $this->precio_1,
            'fecha_1' => $this->fecha_1,
            'precio_2' => $this->precio_2,
            'fecha_2' => $this->fecha_2,
            'precio_3' => $this->precio_3,
            'fecha_3' => $this->fecha_3,
        ]);

        $query->andFilterWhere(['like', 'orden_1', $this->orden_1])
            ->andFilterWhere(['like', 'orden_2', $this->orden_2])
            ->andFilterWhere(['like', 'orden_3', $this->orden_3]);

        return $dataProvider;
    }
}
